r2100 db 0  ;Screen Display Register  x000bbbb x1=Off bbbb=brightness
r2101 db 0  ;OAM Size Register  sssnnbbb  s=size n=name  b=base
r2102 db 0  ;OAM Address Register  aaaaaaaa r000000m
r2103 db 0  ;"
r2104 dw 0  ;OAM data register
r2105 db 0  ;Screen mode register 
r2106 db 0  ;Screen pixelation register
r2107 db 0  ;BG1 VRAM location reg.
r2108 db 0  ;BG2 "
r2109 db 0  ;BG3 "
r210A db 0  ;BG4 "
r210B db 0  ;BG1/2 VRAM location reg.
r210C db 0  ;BG3/4 VRAM location reg.
r210D dw 0  ;BG1 horiz. scroll reg.
r210E dw 0  ;BG1 vert. scroll reg.
r210F dw 0  ;BG2 horiz. scroll reg.
r2110 dw 0  ;BG2 vert. scroll reg.
r2111 dw 0  ;BG3 horiz. scroll reg.
r2112 dw 0  ;BG3 vert. scroll reg.
r2113 dw 0  ;BG4 horiz. scroll reg.
r2114 dw 0  ;BG4 vert. scroll reg.
r2115 db 0  ;Video port control
r2116 db 0  ;Video port address
r2117 db 0  ;"
r2118 db 0  ;Video port data
r2119 db 0  ;"
r211A db 0  ;MODE7 Settings register
r211B db 0  ;M7A
r211C db 0  ;M7B
r211D db 0  ;M7C
r211E db 0  ;M7D
r211F dw 0  ;M7X
r2120 dw 0  ;M7Y
r2121 db 0  ;Color LUT index
r2122 dw 0  ;Color data register
r2123 db 0  ;Window mask settings reg. BG2/1
r2124 db 0  ;Window mask settings reg. BG4/3
r2125 db 0  ;Window mask settings reg. color Window 2/1
r2126 db 0  ;Window 1 left position
r2127 db 0  ;Window 1 right position
r2128 db 0  ;Window 2 left position
r2129 db 0  ;Window 2 right position
r212A db 0  ;Mask logic settings W1/2
r212B db 0  ;Mask logic settings for windows & OBJ Windows
r212C db 0  ;Main screen designation
r212D db 0  ;Sub-screen designation
r212E db 0  ;Window mask main screen designation
r212F db 0  ;Window mask sub screen designation
r2130 db 0  ;Fixed color addition or screen addition register
r2131 db 0  ;Addition/subtraction for screens, BGs, & OBJs
r2132 db 0  ;Fixed color data for fixed color +/-
r2133 db 0  ;Screen mode/video select register
r2134 db 0  ;Multiplication result low
r2135 db 0  ;Multiplication result mid
r2136 db 0  ;Multiplication result high
r2137 db 0  ;Software latch for horizontal/vertical counter
r2138 db 0  ;Read data from OAM
r2139 db 0  ;Read data from VRAM
r213A db 0  ;"
r213B db 0  ;Read data from CG-RAM (color)
r213C dw 0  ;Horizontal scanline location
r213D dw 0  ;Vertical scanline location
r213E db 0  ;PPU status flag & version number
r213F db 0  ;PPU status flag & version number
r2140 db 0  ;APUI00
r2141 db 0  ;APUI01
r2142 db 0  ;APUI02
r2143 db 0  ;APUI03
;------------------
r2180 db 0  ;Read/Write WRAM reg.  (whatever the hell THAT is)
r2181 db 0  ;WRAM data register (low)
r2182 db 0  ;WRAM data register (mid)
r2183 db 0  ;WRAM data register (high)
;------------------
r4200 db 0  ;Counter enable
r4201 db 0  ;Programmable I/O port
r4202 db 0  ;Multiplicand 'A'
r4203 db 0  ;Multiplier 'B'
r4204 db 0  ;Dividend 'C'
r4205 db 0  ;"
r4206 dw 0  ;Divisor B  (byte oprand with one byte padding)
r4207 db 0  ;Video horizontal IRQ beam position/pointer
r4208 db 0  ;"
r4209 db 0  ;Video vertical IRQ beam position/pointer
r420A db 0  ;"
r420B db 0  ;DMA enable register
r420C db 0  ;HDMA enable register
r420D db 0  ;Cycle speed register
r4210 db 0  ;NMI register
r4211 db 0  ;Video IRQ register
r4212 db 0  ;Status register
r4213 db 0  ;Programmable I/O port
r4214 db 0  ;Quotient of divide result
r4215 db 0  ;"
r4216 db 0  ;Multiplication or divide result
r4217 db 0  ;"
r4218 db 0  ;Joypad #1 status register Low
r4219 db 0  ;Joypad #1 status register High
r421A db 0  ;Joypad #2 status register Low
r421B db 0  ;Joypad #2 status register High
r421C db 0  ;Joypad #3 status register Low
r421D db 0  ;Joypad #3 status register High
r421E db 0  ;Joypad #4 status register Low
r421F db 0  ;Joypad #4 status register High
;--------------------
r4300 db 80h DUP (0)   ;DMA/HDMA registers



rr21STD:
  jmp rr21End

rr21NoImp:
  jmp rr21End
rr2140:
  mov al,0aah
  mov [eSS1],2
  jmp rr21End
rr2141:
  mov al,0bbh
  mov [eSS1],2
  jmp rr21End
rr2142:
  mov al,0bbh
  mov [eSS1],2
  jmp rr21End
rr2143:
  mov al,0aah
  mov [eSS1],2
  jmp rr21End
rr2180:
  mov ah,[r2183]
  mov bx,WORD PTR [r2181]
  call MemRead
  inc WORD PTR [r2181]
  adc [r2183],0
  jmp rw21End
rr213B:
  cmp BYTE PTR [r213B],0
  jnz SHORT rw213BS
  mov bl,[r2121]
  xor bh,bh
  shl bx,1
  mov al,BYTE PTR [vCLUT+bx]
  mov BYTE PTR [r213B],1
  jmp rr21End
  rw213BS:
  mov bl,[r2121]
  xor bh,bh
  shl bx,1
  mov al,BYTE PTR [vCLUT+bx+1]
  mov BYTE PTR [r213B],0
  inc [r2121]
  jmp rw21End
rr2139:
  xor ebx,ebx
  mov fs,bx
  mov bx,WORD PTR [r2116]
  add ebx,[mVRAM]
  mov al,fs:[ebx]
  test [r2115],80h
  jnz SHORT rw2139S
  ;implement multi-size increments!
  inc WORD PTR [r2116]
  inc WORD PTR [r2116]
  rw2139S:
  jmp rr21End
rr213A:
  xor ebx,ebx
  mov fs,bx
  mov bx,WORD PTR [r2116]
  inc ebx
  add ebx,[mVRAM]
  mov al,fs:[ebx]
  test [r2115],80h
  jz SHORT rr213AS
  ;implement multi-size increments!
  inc WORD PTR [r2116]
  inc WORD PTR [r2116]
  rr213AS:
  jmp rw21End


rr21Table dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr2139,rr213A,rr213B,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr2140,rr2141,rr2142,rr2143,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr2180,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD
          dw rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD,rr21STD

r21Read PROC NEAR
  push bx
  sub bx,2100h
  shl bx,1
  jmp CS:[bx+OFFSET rr21Table]
  rr21End:
  pop bx
  ret
ENDP

rw21STD:
  jmp rw21End

rw21NoImp:
  jmp rw21End

rw2100:
  mov [r2100],al
  jmp rw21End
rw2105:
  mov BYTE PTR [vTILESIZE],al
  and al,07h
  mov [vMODE],al
  jmp rw21End
rw2107:
  push ax
  mov [vSC1],al
  shr al,2
  xor ah,ah
  cwde
  shl ax,11
  add eax,[mVRAM]
  mov [vBG1],eax
  pop ax
  jmp rw21End
rw2108:
  push ax
  mov [vSC2],al
  shr al,2
  xor ah,ah
  cwde
  shl ax,11
  add eax,[mVRAM]
  mov [vBG2],eax
  pop ax
  jmp rw21End
rw2109:
  push ax
  mov [vSC3],al
  shr al,2
  xor ah,ah
  cwde
  shl ax,11
  add eax,[mVRAM]
  mov [vBG3],eax
  pop ax
  jmp rw21End
rw210A:
  mov fs,ax
  mov [vSC4],al
  shr al,2
  xor ah,ah
  cwde
  shl ax,11
  add eax,[mVRAM]
  mov [vBG4],eax
  mov ax,fs
  jmp rw21End
rw210B:
  mov fs,ax
  and al,0fh
  xor ah,ah
  cwde
  shl ax,13
  add eax,[mVRAM]
  mov [vTILE1],eax
  mov ax,fs
  and al,0f0h
  xor ah,ah
  cwde
  shl ax,9
  add eax,[mVRAM]
  mov [vTILE2],eax
  mov ax,fs
  jmp rw21End
rw210C:
  mov fs,ax
  and al,0fh
  xor ah,ah
  cwde
  shl ax,13
  add eax,[mVRAM]
  mov [vTILE3],eax
  mov ax,fs
  and al,0f0h
  xor ah,ah
  cwde
  shl ax,9
  add eax,[mVRAM]
  mov [vTILE4],eax
  mov ax,fs
  jmp rw21End
rw2115:
  mov [r2115],al
  jmp rw21End
rw2116:
  mov [r2116],al
  jmp rw21End
rw2117:
  mov [r2117],al
  shl WORD PTR [r2116],1
  jmp rw21End
rw2118:
  xor ebx,ebx
  mov fs,bx
  mov bx,WORD PTR [r2116]
  add ebx,[mVRAM]
  mov fs:[ebx],al
  test [r2115],80h
  jnz SHORT rw2118S
  ;implement multi-size increments!
  inc WORD PTR [r2116]
  inc WORD PTR [r2116]
  rw2118S:
  jmp rw21End
rw2119:
  xor ebx,ebx
  mov fs,bx
  mov bx,WORD PTR [r2116]
  inc ebx
  add ebx,[mVRAM]
  mov fs:[ebx],al
  test [r2115],80h
  jz SHORT rw2119S
  ;implement multi-size increments!
  inc WORD PTR [r2116]
  inc WORD PTR [r2116]
  rw2119S:
  jmp rw21End

rw2121:
  mov [r2121],al
  jmp rw21End
rw2122:
  cmp BYTE PTR [r2122],0
  jnz SHORT rw2122S
  mov bl,[r2121]
  xor bh,bh
  shl bx,1
  mov BYTE PTR [vCLUT+bx],al
  mov BYTE PTR [r2122],1
  jmp rw21End
  rw2122S:
  mov bl,[r2121]
  xor bh,bh
  shl bx,1
  mov BYTE PTR [vCLUT+bx+1],al
  mov BYTE PTR [r2122],0
  IFDEF VIDEOON
    mov cx,[vCLUT+bx]
    mov dh,cl
    and dh,31
    shl dh,1
    shl cx,4
    and ch,62
    shr al,1
    mov cl,al
    mov bl,[r2121]
    xor bh,bh
    mov ax,1010h
    int 10h
  ENDIF
  inc [r2121]
  jmp rw21End
rw212C:
  mov [r212C],al
  jmp rw21End
rw210E:
  cmp [r210E],0
  jne rw210ES
  mov [r210E],1
  mov BYTE PTR [vBG1VOff],al
  jmp rw21End
  rw210ES:
  mov [r210E],0
  mov bl,BYTE PTR [vBG1VOff]
  mov bh,al
  shl bx,8
  mov [vBG1VOff],bx
  jmp rw21End
rw2110:
  cmp [r2110],0
  jne rw2110S
  mov [r2110],1
  mov BYTE PTR [vBG2VOff],al
  jmp rw21End
  rw2110S:
  mov [r2110],0
  mov bh,al
  mov bl,BYTE PTR [vBG2VOff]
  shl bx,8
  mov [vBG2VOff],bx
  jmp rw21End
rw2112:
  cmp [r2112],0
  jne rw2112S
  mov [r2112],1
  mov BYTE PTR [vBG3VOff],al
  jmp rw21End
  rw2112S:
  mov [r2112],0
  mov bh,al
  mov bl,BYTE PTR [vBG3VOff]
  shl bx,8
  mov [vBG3VOff],bx
  jmp rw21End
rw2114:
  cmp [r2114],0
  jne rw2114S
  mov [r2114],1
  mov BYTE PTR [vBG4VOff],al
  jmp rw21End
  rw2114S:
  mov [r2114],0
  mov bh,al
  mov bl,BYTE PTR [vBG4VOff]
  shl bx,8
  mov [vBG4VOff],bx
  jmp rw21End
rw210D:
  cmp [r210D],0
  jne rw210DS
  mov [r210D],1
  mov BYTE PTR [vBG1HOff],al
  jmp rw21End
  rw210DS:
  mov [r210D],0
  mov BYTE PTR [vBG1HOff+1],al
  jmp rw21End
rw210F:
  cmp [r210F],0
  jne rw210FS
  mov [r210F],1
  mov BYTE PTR [vBG2HOff],al
  jmp rw21End
  rw210FS:
  mov [r210F],0
  mov BYTE PTR [vBG2HOff+1],al
  jmp rw21End
rw2111:
  cmp [r2111],0
  jne rw2111S
  mov [r2111],1
  mov BYTE PTR [vBG3HOff],al
  jmp rw21End
  rw2111S:
  mov [r2111],0
  mov BYTE PTR [vBG3HOff+1],al
  jmp rw21End
rw2113:
  cmp [r2113],0
  jne rw2113S
  mov [r2113],1
  mov BYTE PTR [vBG4HOff],al
  jmp rw21End
  rw2113S:
  mov [r2113],0
  mov BYTE PTR [vBG4HOff+1],al
  jmp rw21End
rw2181:
  mov [r2181],al
  jmp rw21End
rw2182:
  mov [r2182],al
  jmp rw21End
rw2183:
  mov [r2183],al
  jmp rw21End
rw2180:
  mov ah,[r2183]
  mov bx,WORD PTR [r2181]
  call MemWrite
  inc WORD PTR [r2181]
  adc [r2183],0
  jmp rw21End



rw21Table dw rw2100,rw21STD,rw21STD,rw21STD,rw21STD,rw2105,rw21STD,rw2107
          dw rw2108,rw2109,rw210A,rw210B,rw210C,rw210D,rw210E,rw210F
          dw rw2110,rw2111,rw2112,rw2113,rw2114,rw2115,rw2116,rw2117
          dw rw2118,rw2119,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw2121,rw2122,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw212C,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw2180,rw2181,rw2182,rw2183,rw21STD,rw21STD,rw21STD,rw21STD
          dw rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD,rw21STD

r21Write PROC NEAR
  mov di,bx
  sub bx,2100h
  shl bx,1
  jmp CS:[bx+OFFSET rw21Table]
  rw21End:
  mov bx,di
  ret
ENDP

dTYPE   db 0

rDMARD MACRO
  LOCAL rDMARD1,rDMARD2
  test dl,16
  jnz SHORT rDMARD1
  test dl,8
  jnz SHORT rDMARD2
  inc si
  jmp SHORT rDMARD1
  rDMARD2:
  dec si
  rDMARD1:
ENDM

rDMAEX PROC NEAR
  cmp [dTYPE],0
  jne rDMA2
    rDMA1L:
    mov bx,si
    mov ah,dh
    call MemRead
    mov bx,cx
    xor ah,ah
    call MemWrite
    rDMARD
    mov bx,si
    mov ah,dh
    call MemRead
    mov bx,cx
    xor ah,ah
    call MemWrite
    rDMARD
    dec bp
    jz SHORT rDMA1F
    dec bp
    rDMA1F:
    jnz rDMA1L
    ret
  rDMA2:
  cmp [dTYPE],1
  jne rDMA3
    rDMA2L:
    mov bx,si
    mov ah,dh
    call MemRead
    mov bx,cx
    xor ah,ah
    call MemWrite
    rDMARD
    mov bx,si
    mov ah,dh
    call MemRead
    mov bx,cx
    inc bx
    xor ah,ah
    call MemWrite
    rDMARD
    dec bp
    jz SHORT rDMA2F
    dec bp
    rDMA2F:
    jnz rDMA2L
    ret
  rDMA3:
  cmp [dTYPE],2
  jne rDMA4
    rDMA3L:
    mov bx,si
    mov ah,dh
    call MemRead
    mov bx,cx
    xor ah,ah
    call MemWrite
    rDMARD
    dec bp
    jnz rDMA3L
    ret
  rDMA4:
  cmp [dTYPE],3
  jne rDMA5
    ;This DMA mode isn't implemented   (because it seems pointless)
  rDMA5:
  cmp [dTYPE],4
  jne rDMA6
    ;This DMA mode isn't implemented either (because it is REALLY pointless)
  rDMA6:
  ret
ENDP

rw42STD:
  jmp rw42End

rw4200:
  mov [r4200],al
  jmp rw42End

rw420B:
  push dx
  push cx
  push ax

  mov [r420B],al
  test [r420B],1
  jz rw420B1
    mov si,WORD PTR [r4300+2]
    mov dl,[r4300]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1]
    mov bp,WORD PTR [r4300+5]
    mov dh,[r4300+4]
    mov ch,21h
    call rDMAEX
  rw420B1:
  ;Implement other DMA channels here
  test [r420B],2
  jz rw420B2
    mov si,WORD PTR [r4300+2+10h]
    mov dl,[r4300+10h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+10h]
    mov bp,WORD PTR [r4300+5+10h]
    mov dh,[r4300+4+10h]
    mov ch,21h
    call rDMAEX
  rw420B2:
  test [r420B],4
  jz rw420B3
    mov si,WORD PTR [r4300+2+20h]
    mov dl,[r4300+20h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+20h]
    mov bp,WORD PTR [r4300+5+20h]
    mov dh,[r4300+4+20h]
    mov ch,21h
    call rDMAEX
  rw420B3:
  test [r420B],8
  jz rw420B4
    mov si,WORD PTR [r4300+2+30h]
    mov dl,[r4300+30h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+30h]
    mov bp,WORD PTR [r4300+5+30h]
    mov dh,[r4300+4+30h]
    mov ch,21h
    call rDMAEX
  rw420B4:
  test [r420B],16
  jz rw420B5
    mov si,WORD PTR [r4300+2+40h]
    mov dl,[r4300+40h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+40h]
    mov bp,WORD PTR [r4300+5+40h]
    mov dh,[r4300+4+40h]
    mov ch,21h
    call rDMAEX
  rw420B5:
  test [r420B],32
  jz rw420B6
    mov si,WORD PTR [r4300+2+50h]
    mov dl,[r4300+50h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+50h]
    mov bp,WORD PTR [r4300+5+50h]
    mov dh,[r4300+4+50h]
    mov ch,21h
    call rDMAEX
  rw420B6:
  test [r420B],64
  jz rw420B7
    mov si,WORD PTR [r4300+2+60h]
    mov dl,[r4300+60h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+60h]
    mov bp,WORD PTR [r4300+5+60h]
    mov dh,[r4300+4+60h]
    mov ch,21h
    call rDMAEX
  rw420B7:
  test [r420B],128
  jz rw420B8
    mov si,WORD PTR [r4300+2+70h]
    mov dl,[r4300+70h]
    mov [dTYPE],dl
    and [dTYPE],7
    mov cl,[r4300+1+70h]
    mov bp,WORD PTR [r4300+5+70h]
    mov dh,[r4300+4+70h]
    mov ch,21h
    call rDMAEX
  rw420B8:
  mov [r420B],0
  pop ax
  pop cx
  pop dx
  jmp rw42End
rw4202:
  mov [r4202],al
  jmp rw42End
rw4203:
  push ax
  mov [r4203],al
  mul [r4202]
  mov WORD PTR [r4216],ax
  pop ax
  jmp rw42End
rw4204:
  mov [r4204],al
  jmp rw42End
rw4205:
  mov [r4205],al
  jmp rw42End
rw4206:
  mov BYTE PTR [r4206],al
  cmp al,0
  je rw4206DZ
  push ax
  push dx
  mov ax,WORD PTR [r4204]
  div [r4206]
  mov WORD PTR [r4214],ax
  mov WORD PTR [r4216],dx
  pop dx
  pop ax
  jmp rw42End
  rw4206DZ:
  mov WORD PTR [r4214],0
  mov WORD PTR [r4216],0
  jmp rw42End
rw4207:
  mov [r4207],al
  jmp rw42End
rw4208:
  mov [r4208],al
  jmp rw42End
rw4209:
  mov [r4209],al
  jmp rw42End
rw420A:
  mov [r420A],al
  jmp rw42End
rw420D:
  test al,1
  jz rw420DS
  mov [eINSTPC],20000d     ;3.58 Mhz / 3 cyc per inst. /60 NMI/sec 
  jmp rw42End
  rw420DS:
  mov [eINSTPC],15000d     ;3.68 Mhz / 3 cyc per inst. /60 NMI/sec 
  jmp rw42End



rw42Table dw rw4200,rw42STD,rw4202,rw4203,rw4204,rw4205,rw4206,rw4207
          dw rw4208,rw4209,rw420A,rw420B,rw42STD,rw420D,rw42STD,rw42STD
          dw rw42STD,rw42STD,rw42STD,rw42STD,rw42STD,rw42STD,rw42STD,rw42STD
          dw rw42STD,rw42STD,rw42STD,rw42STD,rw42STD,rw42STD,rw42STD,rw42STD

r42Write PROC NEAR
  mov di,bx
  sub bx,4200h
  shl bx,1
  jmp CS:[bx+OFFSET rw42Table]
  rw42End:
  mov bx,di
  ret
ENDP

rr42STD:
  jmp rr42End
rr4210:
  mov al,[r4210]
  mov [r4210],0
  jmp rr42End
rr4214:
  mov al,[r4214]
  jmp rr42End
rr4215:
  mov al,[r4215]
  jmp rr42End
rr4216:
  mov al,[r4216]
  jmp rr42End
rr4217:
  mov al,[r4217]
  jmp rr42End


rr42Table dw rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD
          dw rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD
          dw rr4210,rr42STD,rr42STD,rr42STD,rr4214,rr4215,rr4216,rr4217
          dw rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD,rr42STD

r42Read PROC NEAR
  mov di,bx
  sub bx,4200h
  shl bx,1
  jmp CS:[bx+OFFSET rr42Table]
  rr42End:
  mov bx,di
  ret
ENDP

r43Write PROC NEAR
  mov si,bx
  sub bx,4300h
  mov CS:[bx+r4300],al
  mov bx,si
  ret
ENDP

r43Read PROC NEAR
  mov si,bx
  sub bx,4300h
  mov al,CS:[bx+r4300]
  mov bx,si
  ret
ENDP


